'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 9 December 2004 at 10:20:25 pm'!

!Cursor class methodsFor: 'instance creation' stamp: 'jmv 10/27/2004 20:35'!
resizeForEdge: aSymbol 
	"Cursor resizeForEdge: #top"
	"Cursor resizeForEdge: #bottomLeft"
	
	"Do not erase this literal, as it helps 'senders' worl properly"
	#(#resizeBottom #resizeBottomLeft #resizeBottomRight #resizeLeft #resizeRight #resizeTop #resizeTopLeft #resizeTopRight ) yourself.
	
	^ self perform: ('resize' , aSymbol first asString asUppercase
			, (aSymbol copyFrom: 2 to: aSymbol size)) asSymbol! !


!DataStream class methodsFor: 'as yet unclassified' stamp: 'jmv 12/9/2004 20:29'!
cleanup
	(TypeMap keys select: [ :a | a isObsolete]) do: [ :each | TypeMap removeKey: each ]! !


!Morph methodsFor: 'menus' stamp: 'jmv 10/27/2004 20:34'!
adhereToEdge: edgeSymbol 
	(owner isNil or: [owner isHandMorph]) ifTrue: [^self].
	
	"serves as sender"
	#adjustedCenter: yourself.
	
	self perform: (edgeSymbol , ':') asSymbol
		withArguments: (Array with: (owner perform: edgeSymbol))! !


!NewParagraph methodsFor: 'private' stamp: 'jmv 10/20/2004 15:58'!
lastLine
	^lines last! !


!Paragraph methodsFor: 'private' stamp: 'jmv 10/20/2004 15:58'!
lastLine
 ^lines at: lastLine! !


!ParagraphEditor methodsFor: 'nonediting/nontyping keys' stamp: 'jmv 10/20/2004 15:58'!
cursorEnd: characterStream 

	"Private - Move cursor end of current line."
	| string |
	self closeTypeIn: characterStream.
	string _ paragraph text string.
	self
		moveCursor:
			[:position | Preferences wordStyleCursorMovement
				ifTrue:[| targetLine |
					targetLine _ paragraph lines at:(paragraph lineIndexOfCharacterIndex: position).
					targetLine = paragraph lastLine
						ifTrue:[targetLine last + 1]
						ifFalse:[targetLine last]]
				ifFalse:[
					string
						indexOf: Character cr
						startingAt: position
						ifAbsent:[string size + 1]]]
		forward: true
		specialBlock:[:dummy | string size + 1].
	^true! !


!Preferences class methodsFor: 'misc' stamp: 'jmv 12/9/2004 22:20'!
cleanUp
	| dict |
	dict _ DictionaryOfPreferences.
	
	(dict keys select: [ :each |
	(((dict at: each) instVarNamed: 'changeInformee') isKindOf: Behavior) and: [
		((dict at: each) instVarNamed: 'changeInformee') isObsolete ]]) do: [ :eachKey |
			dict removeKey: eachKey ].
		
	dict _ self parameterAt: #PersonalDictionaryOfPreferences ifAbsent: [^ self].

	(dict keys select: [ :each |
	(((dict at: each) instVarNamed: 'changeInformee') isKindOf: Behavior) and: [
		((dict at: each) instVarNamed: 'changeInformee') isObsolete ]]) do: [ :eachKey |
			dict removeKey: eachKey ].! !


!SystemNavigation methodsFor: 'query' stamp: 'jmv 10/23/2004 11:04'!
addAllSymbolsIn: aLiteral to: aCollection exceptFor: symbolNotToInclude
	(aLiteral isMemberOf: Symbol) ifTrue: [
		aLiteral == symbolNotToInclude ifFalse: [aCollection add: aLiteral].
		^self].
	(aLiteral isMemberOf: Array) ifTrue: [
		aLiteral do: [ :eachLiteral |
			self addAllSymbolsIn: eachLiteral to: aCollection exceptFor: symbolNotToInclude]]! !

!SystemNavigation methodsFor: 'query' stamp: 'jmv 10/25/2004 21:59'!
allGlobalRefsWithout: classesAndMessagesPair 
	"Answer a set of symbols that may be refs to Global names. In some  
	sense we should only need the associations, but this will also catch, eg,  
	HTML tag types. This method computes its result in the absence of  
	specified classes and messages."
	"may be a problem if namespaces are introduced as for the moment  
	only Smalltalk is queried. sd 29/4/03"
	| globalRefs absentClasses absentSelectors |
	globalRefs _ IdentitySet new: CompiledMethod instanceCount.
	absentClasses _ classesAndMessagesPair first.
	absentSelectors _ classesAndMessagesPair second.
	self flag: #shouldBeRewrittenUsingSmalltalkAllClassesDo:.
	"sd 29/04/03"
	Cursor execute
		showWhile: [Smalltalk classNames
				do: [:cName | ((absentClasses includes: cName)
						ifTrue: [{}]
						ifFalse: [{Smalltalk at: cName. (Smalltalk at: cName) class}])
						do: [:cl | (absentSelectors isEmpty
								ifTrue: [cl selectors]
								ifFalse: [cl selectors copyWithoutAll: absentSelectors])
								do: [:sel | "Include all capitalized symbols for good measure"
									(cl compiledMethodAt: sel) literals
										do: [:m | 
											((m isMemberOf: Symbol)
													and: [m size > 0
															and: [m first isUppercase]])
												ifTrue: [m = cl name ifFalse: [globalRefs add: m]].
											(m isMemberOf: Array)
												ifTrue: [m
														do: [:x | ((x isMemberOf: Symbol)
																	and: [x size > 0
																			and: [x first isUppercase]])
																ifTrue: [m = cl name ifFalse: [globalRefs add: x]]]].
											m isVariableBinding
												ifTrue: [m key
														ifNotNil: [m key = cl name ifFalse: [globalRefs add: m key]]]]]]]].
	^ globalRefs! !

!SystemNavigation methodsFor: 'query' stamp: 'jmv 10/23/2004 11:06'!
allSentMessagesWithout: classesAndMessagesPair 
	"Answer the set of selectors which are sent somewhere in the system,  
	computed in the absence of the supplied classes and messages."
	| sent absentClasses absentSelectors |
	sent _ IdentitySet new: CompiledMethod instanceCount.
	absentClasses _ classesAndMessagesPair first.
	absentSelectors _ classesAndMessagesPair second.
	self flag: #shouldBeRewrittenUsingSmalltalkAllClassesDo:.
	"sd 29/04/03"
	Cursor execute
		showWhile: [Smalltalk classNames
				do: [:cName | ((absentClasses includes: cName)
						ifTrue: [{}]
						ifFalse: [{Smalltalk at: cName. (Smalltalk at: cName) class}])
						do: [:cl | (absentSelectors isEmpty
								ifTrue: [cl selectors]
								ifFalse: [cl selectors copyWithoutAll: absentSelectors])
								do: [:sel | "Include all sels, but not if sent by self"
									self addAllSymbolsIn: (cl compiledMethodAt: sel) literals to: sent exceptFor: sel ]]].
			"The following may be sent without being in any literal frame"
			1
				to: Smalltalk specialSelectorSize
				do: [:index | sent
						add: (Smalltalk specialSelectorAt: index)]].
	Smalltalk presumedSentMessages
		do: [:sel | sent add: sel].
	^ sent! !

